extends KinematicBody2D

var au_sol = true
const UP = Vector2(0,-1)                 #Définir le point haut
export var GRAVITY = 20                  #Définir la force de gravité
export var MAXFALLSPEED = 400
export var MAXSPEED = 200
export var JUMPFORCE = 350               #Définir la force du saut
var jump_count = 0
export var ACCEL = 200
var mouvement = Vector2()


func _ready():
	pass
	
	
func _physics_process(delta):
	
	#Parametres de gravité et de chute
	mouvement.y += GRAVITY
	if mouvement.y > MAXFALLSPEED:
		mouvement.y = MAXFALLSPEED
	
	#Parametres de déplacement
	mouvement.x = clamp(mouvement.x,-MAXSPEED,MAXSPEED)

	if Input.is_action_pressed("ui_right"):
		mouvement.x += ACCEL
	elif Input.is_action_pressed("ui_left"):
		mouvement.x += -ACCEL
	else:
		mouvement.x = lerp(mouvement.x,0,0.2)    #Interpolation de valeurs de ma variable
	
	#Parametres de saut
	if Input.is_action_just_pressed("ui_up"):
		if jump_count < 1:                       #Double saut
			jump_count += 1
			mouvement.y = -JUMPFORCE
			au_sol = false
	
	#Si je touche le sol, je peux sauter
	if is_on_floor(): 
		au_sol = true
		jump_count = 0
	else:
		au_sol = false
	
	
	#Definir la méthode de déplacement, du type de collision et le point haut
	mouvement = move_and_slide(mouvement, UP) 
	
	# Je veux savoir qui je collisionne
	for QuiJeCogne in get_slide_count():
		var collision = get_slide_collision(QuiJeCogne)
		print('Je cogne : ' + collision.collider.name)
		if collision.collider.name == "Caisse3_Body":
			print ('Aie, je perds de l energie')

#Area2D a été touché par mon player
func Mon_body_touche_un_ITEM(body):
	print ('Je gagne de l energie')
	get_parent().get_node("Area2D").queue_free()    #Je desactive le noeud Area2D

